AC_DEFUN([AC_GDS_PROG_CXX],
  [ AC_PROG_CC
    AC_PROG_CXX
    AS_IF( [ test "${GXX}" = "yes" ],
           [ touch ,t.cc
             ac_dmt_default_cxx_includes="`${CXX} -v ,t.cc 2>&1 | \
             sed -n -e '/\#include/,/End of search list\./p' | \
             egrep '^ '`"
             rm ,t.cc ] )
    use_std=""
    AS_IF( [ test `echo $CXXFLAGS | grep -c -- '-std='` = 0 ],
           [use_std="-std=c++17"] )
    GDS_CXX_FLAVOR="generic"
    AS_CASE( [$CXX],
             [gcc|*/gcc|g++|*/g++|g++-mp-*|*/g++-mp-*|clang++|*/clang++],[
               GDS_CXX_FLAVOR="gnu"
               CXXFLAGS="${CXXFLAGS} -g $use_std"
               AS_IF( [test `$CXX --version | grep -c clang` != 0 ],
                      [GDS_CXX_FLAVOR="clang"] ) ],
             [icc|*/icc|icpc|*/icpc],[
               GDS_CXX_FLAVOR="intel"
               CXXFLAGS="${CXXFLAGS} $use_std"],
             [CC|*/CC],[
               AS_CASE( ["`$CXX -V 2>&1`"],
                 [*Sun\ C++*],[GDS_CXX_FLAVOR="SunPRO"],
                 [] ) ],
             [] )
    CXXFLAGS=`echo ${CXXFLAGS} | sed -e s,-O2,,g`
    AC_SYS_LARGEFILE
    AM_CONDITIONAL([GDS_CXX_SUNPRO],[test x$GDS_CXX_FLAVOR = xSunPRO])
  ])

